#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf hiawatha-7.8.2.tar.gz
    cd hiawatha-7.8.2
    ./configure --prefix=/usr --sysconfdir=/etc --localstatedir=/var \
	    --disable-ssl --disable-xslt
    make
    strip -R .note -R .comment hiawatha cgi-wrapper php-fcgi
    mkdir -p ../hiawatha/sbin
    cp hiawatha cgi-wrapper php-fcgi ../hiawatha/sbin/
    chmod u+s ../hiawatha/sbin/cgi-wrapper
    cd ..
    rm -rf hiawatha-7.8.2
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
